// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.bpm.QuickStart.step.ServerStatus");
dojo.require("com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper");

dojo.declare("com.ibm.bpm.QuickStart.step.ServerStatus", null, {

    maxInterval:1200000,
    stepInterval:15000,
    currentInterval:0,
    stepCheckerReference:null,
    callbackReference:null,
    isStepSuccess:false,
    execute: function(){
            setTimeout(dojo.hitch(this, "checkServerStatus"),0);
    },
    getIsStepSuccess: function(){
        return this.isStepSuccess;
    },
    setIsStepSuccess: function(value){
        this.isStepSuccess = value;
    },
    checkServerStatus: function(){
        com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getStaticLogger().entering("ServerStatus","checkServerStatus","starting checkServerStatus");
        if(this.currentInterval>this.maxInterval){
            this.setIsStepSuccess(false);
            this.callbackReference(); //show error dialog
            return; 
        }else {
            this.currentInterval= this.currentInterval + this.stepInterval;
            if(this.stepCheckerReference()){
                this.setIsStepSuccess(true);
                this.callbackReference();  // loadConsole
                return;
            }
        }
        com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getStaticLogger().exiting("ServerStatus","checkServerStatus","Before Settimeout with interval"+this.currentInterval );
        setTimeout(dojo.hitch(this, "checkServerStatus"), this.stepInterval);
    }

});
