// Licensed Materials - Property of IBM
// 5725-C94 5725-C95 5725-C96 5724-M24 5724-I82 5724-N72 5655-WBS 
// Copyright IBM Corporation 2011, 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.


dojo.provide("com.ibm.bpm.QuickStart.ui.dialogs.CellCredentialsDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Form");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.bpm.QuickStart.ui.textbox.UserPassTextBox");

//dojo.require("com.ibm.bpm.install.utils.Message");

dojo.declare("com.ibm.bpm.QuickStart.ui.dialogs.CellCredentialsDialog", [dijit._Widget, dijit._Templated], {

    // Template information
    templatePath: dojo.moduleUrl("com.ibm.bpm.QuickStart.ui.dialogs.CellCredentialsDialog", "../templates/CellCredentialsDialog.html"),
    widgetsInTemplate: true,
    labels: {},
    _connections: null,
    callerOkCallback: null,
    callerCancelCallback: null,
    callerCallback:null,
    
    // Dialog properties
    data: null,
    
    // Load all labels	
    postMixInProperties: function(){
        this.inherited(arguments);
        
        this.labels.TITLE = property("CellCredentailsDialogTitle");
        this.labels.USERNAME = property("CellCredentailsUsername");
        this.labels.PASSWORD = property("CellCredentailsPassword");
        this.labels.YES = property("dialogLogin");
        this.labels.NO = property("dialogCancel");
    },
    
    // @Override
    postCreate: function(){
        this.inherited(arguments);
        this._connections = new Array();
        
        
        // Setup connection for buttons
        this._connections.push(dojo.connect(this.yesButton, "onClick", this, "loginCallback"));
        this._connections.push(dojo.connect(this.noButton, "onClick", this, "hide")); 
    },
    
    /*
     * Show method to show the dialog.
     */
    show: function(){
        this.dialog.show();
    },
    
    /*
     * Custom hide method that hides the dialog, then destroys this widget.
     */
    hide: function(){
        this.dialog.hide();
        this.destroyRecursive();
    },
    
    // Show first steps
    loginCallback: function(){
    if(!(this.getUserId()=="" || this.getPassword()=="")){ 
        this.dialog.hide();
        this.callerOkCallback();
        this.callerCallback();
        this.destroyRecursive();
    }
    },
    
    getUserId: function(){
        return this.userId.attr("value");
    },
    
    getPassword: function(){
        return this.password.attr("value");    
    }
});
