// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.bpm.QuickStart.ui.widgets.QuickStartWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.QuickStart.Consoles.impl.WASAdminConsole");
dojo.require("com.ibm.bpm.QuickStart.model.DeploymentEnvironment");
dojo.require("com.ibm.bpm.QuickStart.Consoles.impl.ProcessCenterConsole");
dojo.require("com.ibm.bpm.QuickStart.UtilitiesJavaWrapper");
dojo.require("com.ibm.bpm.QuickStart.ui.dialogs.CellCredentialsDialog");
dojo.require("com.ibm.bpm.QuickStart.ui.dialogs.ErrorDialog");
dojo.require("com.ibm.bpm.QuickStart.step.ServerStatus");
dojo.require("com.ibm.bpm.QuickStart.utils.Message");


/*
 * Quick Start main widget.
 */
dojo.declare("com.ibm.bpm.QuickStart.ui.widgets.QuickStartWidget", [dijit._Widget, dijit._Templated], {
    // Template information
    templateString:dojo.cache("com.ibm.bpm.QuickStart.ui.widgets.QuickStartWidget", "../templates/QuickStartWidget.html"),
    section: {"systemStatus":{},"documentation":{},"processApplication":{"title":[],"processCenter":{},"portal":{}},"adminConsole":{"title":[],"webSphere":{},"processAdmin":{},"performanceDataWarehouse":{}},"serverAdministration":{"start":{},"stop":{},"title":[]}, "dep":{"title":[],"processCenter":{"start":{},"stop":{}},"processServer":{"start":{},"stop":{}}}},
    de:null,
    dmgr:null,
    cellCredentialsDialogReference:null,
    clazz:"QuickStartWidget",
    logger:null,
    serverStatusChecker:null,
    cellUserName: null,
    cellPassword: null,
    //137696 (0 - command prompt mode 1 - shortcuts mode)
    mode:1,

    postCreate: function(){
      this.inherited(arguments);
    },
    
    //@Override 
    postMixInProperties: function(){
        this.inherited(arguments);
      var productID = com.ibm.bpm.QuickStart.Helpers.WCCMHelper.getProductId(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome());
      var fullProductName = top.formatmsg(property('QuickStart.name'),property(productID+'.product'));
      var deName=com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getDeName();
      var pflName=com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName();
      this.TITLE=top.formatmsg(property('Deployment.Environment.title'),fullProductName,deName,pflName);
      this.section.serverAdministration.title=property('section.serverAdministration.title');
      this.section.serverAdministration.start.description=property('section.serverAdministration.start.description');
      this.section.serverAdministration.start.link=property('section.serverAdministration.start.link');
      this.section.serverAdministration.stop.link=property('section.serverAdministration.stop.link');
      this.section.serverAdministration.stop.description=property('section.serverAdministration.stop.description');
      
      this.section.systemStatus=property('section.systemStatus');
      
	  this.section.dep.info=property('section.de.info.retrieve');
	  
      this.section.dep.title=property('section.de.title');
      this.section.dep.processCenter.start.description=property('section.de.processCenter.start.description');
      this.section.dep.processCenter.start.link=property('section.de.processCenter.start.link');
      this.section.dep.processCenter.stop.description=property('section.de.processCenter.stop.description');
      this.section.dep.processCenter.stop.link=property('section.de.processCenter.stop.link');
	  this.section.dep.processCenter.starting=property('section.de.processCenter.starting');
	  this.section.dep.processCenter.stopping=property('section.de.processCenter.stopping');

      this.section.dep.processServer.start.description=property('section.de.processServer.start.description');
      this.section.dep.processServer.start.link=property('section.de.processServer.start.link');
      this.section.dep.processServer.stop.description=property('section.de.processServer.stop.description');
      this.section.dep.processServer.stop.link=property('section.de.processServer.stop.link');
      this.section.dep.processServer.starting=property('section.de.processServer.starting');
	  this.section.dep.processServer.stopping=property('section.de.processServer.stopping');

      this.section.adminConsole.title=property('section.adminConsole.title');
      this.section.adminConsole.webSphere.description=property('section.adminConsole.webSphere.description');
      this.section.adminConsole.webSphere.link=property('section.adminConsole.webSphere.link');
      this.section.adminConsole.processAdmin.description= property('section.adminConsole.processAdmin.description');
      this.section.adminConsole.processAdmin.link=property('section.adminConsole.processAdmin.link');
      this.section.adminConsole.performanceDataWarehouse.description=property('section.adminConsole.performanceDataWarehouse.description');
      this.section.adminConsole.performanceDataWarehouse.link=property('section.adminConsole.performanceDataWarehouse.link');
      
      this.section.processApplication.title=property('section.processApplication.title');
      this.section.processApplication.processCenter.description=property('section.processApplication.processCenter.description');
      this.section.processApplication.processCenter.link=property('section.processApplication.processCenter.link');
      this.section.processApplication.portal.description=property('section.processApplication.portal.description');
      this.section.processApplication.portal.link=property('section.processApplication.portal.link');
      
      // Load Documentation Section
      this.section.documentation.title = property('section.documentation.title');
      this.section.documentation.description = property('section.documentation.description');
      this.section.documentation.link = property('section.documentation.link');
      
    
    },
    
//    addSection: function(){
    
//    },

    addSection: function(sectionTitle){
        var section = document.createElement("dt");
        var sectionTitleTextNode = document.createTextNode(sectionTitle);
        section.appendChild(sectionTitleTextNode);
        return section;
    },
    addConsoleToSection: function(section,console){
        section.appendChild(console);
        return section;
    },
    showthisthing: function(reference){
        dojo.style(reference,"display","block");
    },
    hidethisthing: function(reference){
        dojo.style(reference,"display","none");
    },
    resetControls: function(){
       var method = "resetControls";
       this.logger.entering(this.clazz,method,"Reseting all constols");
       this.hidethisthing(this.sectionServerAdministrationTitle);
       this.hidethisthing(this.serverAdministrationStart);
       this.hidethisthing(this.serverAdministrationStop);

       this.hidethisthing(this.systemApplicationStatusCheck);

       this.hidethisthing(this.sectionDepTitle);
	   this.hidethisthing(this.depinformation);
       this.hidethisthing(this.depProcessCenterStart);
       this.hidethisthing(this.depProcessCenterStop);

       this.hidethisthing(this.depProcessServerStart);
       this.hidethisthing(this.depProcessServerStop);
	   
	   this.hidethisthing(this.depProcessCenterStarting);
	   this.hidethisthing(this.depProcessServerStarting);
	   this.hidethisthing(this.depProcessCenterStopping);
	   this.hidethisthing(this.depProcessServerStopping);

       this.hidethisthing(this.sectionAdminConsoleTitle);
       this.hidethisthing(this.adminConsoleWebSphere);
       this.hidethisthing(this.adminConsoleProcessAdmin);
       this.hidethisthing(this.adminConsolePerformanceDataWarehouse);

       this.hidethisthing(this.sectionProcessApplicationTitle);
       this.hidethisthing(this.processApplicationProcessCenter);
       this.hidethisthing(this.processApplicationPortal);
       this.logger.exiting(this.clazz,method,"Reset all controls");
    },
    
    postCreate: function(){
       var method = "postCreate";

        this.inherited(arguments);
        this.logger= com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getStaticLogger();
        this.logger.entering(this.clazz,method,"Loading all controls and switches");

        this._connections = new Array();
        this._connections.push(dojo.connect(this.sectionDocumentationLink, "onclick", this, function(){
            var deType = this.de.getDeType();
            if(deType==null){
                  viewPage(NO_DISKID,property('Advanced.infoCenter.url'));
            } else {
                  viewPage(NO_DISKID,property(deType + '.infoCenter.url'));
            }
        }));


       this.resetControls();
       var inputProfileName=com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName();
       var inputDEName=com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getDeName();
       
       //137696 (Set QuickStart mode according to start argument )
       var inputUserName = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getUserName(); // will be set if user has passed the parameter during startup
       var inputPassword = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPassword(); // will be set if user has passed the parameter during startup
       //this.setCellUserName(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getUserName());  // will be set if user has passed the parameter during startup
       //this.setCellPassword(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPassword());  // will be set if user has passed the parameter during startup
       if(inputUserName!="" && inputUserName!= null && inputPassword!="" && inputPassword!=null)
       {
       		// 0 - command prompt mode, 1 - shortcuts mode
            this.mode = 0; 
            this.logger.logMessage("The Quick Start console was started from the command line (mode=0), so if the wrong DE user name or password was entered, the user must restart the Quick Start console in order to enter credentials again.");
       }
       this.setCellUserName(inputUserName);  
       this.setCellPassword(inputPassword);  
      //137696 end
      
       if(inputProfileName=="" || inputDEName=="" ){
            // stop quick start - parameter not entered
            var messages=[];
            messages[0] = new com.ibm.bpm.QuickStart.utils.Message("error", property("BPMQuickStart.requiredArguments"));
            messages[1] = new com.ibm.bpm.QuickStart.utils.Message("info", property("BPMQuickStart.Usage"));
            
            com.ibm.bpm.QuickStart.ui.dialogs.ErrorDialog({messages: messages}).show();
            this.logger.logMessage(this.clazz,method,"User didn't enter required parameters");
       } else {
           var profileExists=com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.directoryExists(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome()+"profiles/"+inputProfileName);
           var deExists=com.ibm.bpm.QuickStart.Helpers.WCCMHelper.doesDeploymentEnvironmentExists(inputDEName,com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getBPMHome(),inputProfileName);
           
           if(profileExists && deExists ){
                this.loadPanel();
           } else {
                     var messages=[];
                    if(!profileExists){
                        messages[messages.length]=new com.ibm.bpm.QuickStart.utils.Message("error", top.formatmsg(property("nonExistingProfileName"),inputProfileName));
                        this.logger.logMessage(this.clazz,method,"Non existing profile name has been entered by the user");
                    }
                    
                    if(!deExists){
                        messages[messages.length]=new com.ibm.bpm.QuickStart.utils.Message("error", top.formatmsg(property("nonExistingDeName"),inputDEName));
                        this.logger.logMessage(this.clazz,method,"Non existing de name has been entered by the user");
                    }

                    com.ibm.bpm.QuickStart.ui.dialogs.ErrorDialog({messages: messages}).show();
                
           
           }
           
        }
       this.logger.exiting(this.clazz,method,"End of loading controls and switches");
    },
    setCellUserName: function(userName){
    	//137696 
        //if(this.cellUserName==null && (userName!=null && userName!="")){
        
        // if the mode is 0 (command prompt mode), only set userName at the first time.
        if(this.mode==0 && this.cellUserName==null && (userName!=null && userName!="")){
            this.cellUserName = userName;
        }
        // if the mode is 1 (shortcut mode), re-set userName every time.
        if(this.mode==1 && (userName!=null && userName!="")){
            this.cellUserName = userName;
        }
    },
    getCellUserName: function(){
        return this.cellUserName;
    },
    setCellPassword: function(password){
    	//137696 
        //if(this.cellPassword==null && (password!=null && password !="")){
        
        //if the mode is 0 (command prompt mode), only set password at the first time.
        if(this.mode==0 && this.cellPassword==null && (password!=null && password !="")){
            this.cellPassword = password;
        }
        // if the mode is 1 (shortcut mode), re-set password every time.
        if(this.mode==1 && (password!=null && password !="")){
            this.cellPassword = password;   
        }
    },
    getCellPassword: function(){
        return this.cellPassword;
    },
    cellCredentialDialogOkListener: function(){
       var method = "cellDialogOkListerner";
       this.logger.entering(this.clazz,method,"User has pressed ok");

        if(this.cellCredentialsDialogReference.getUserId()=="" || this.cellCredentialsDialogReference.getPassword() ==""){
        
        } else {
            this.setCellUserName(this.cellCredentialsDialogReference.getUserId());
            this.setCellPassword(this.cellCredentialsDialogReference.getPassword());
            this.de.setCellUserName(this.getCellUserName());
            this.de.setCellPassword(this.getCellPassword());
        }
       
       this.logger.exiting(this.clazz,method,"Exiting CellDialogOkCallback");
    },
    cellCredentialDialogCancelListener: function(){
       var method = "cellDialogListerner";
       this.logger.entering(this.clazz,method,"User has pressed cancel");
       this.logger.exiting(this.clazz,method,"Exiting ok CallbackListener");

    },
    loadPanel: function(){
       var method = "loadPanel";
       this.logger.entering(this.clazz,method,"Loading Panels");
   
       this.dmgr = new com.ibm.bpm.QuickStart.Consoles.impl.WASAdminConsole();
       this.dmgr.constructor("DmgrProfile",com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getProfileName()); //"DmgrProfile" is immaterial
       this.de = new com.ibm.bpm.QuickStart.model.DeploymentEnvironment(com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getDeName(),this.dmgr,this.getCellUserName(),this.getCellPassword());
       //137696
       this.de.setMode(this.mode);
       this.de.loadConsoles();
       this.registerOnClickCallback();
       this.showQuickStartLinks();
       if(this.de.isOnline()==false && this.de.getDmgr() && this.de.getDmgr().isOnline()){
            this.serverStatusChecker = com.ibm.bpm.QuickStart.step.ServerStatus();
            this.serverStatusChecker.stepCheckerReference=dojo.hitch(this,"stepChecker");
            this.serverStatusChecker.callbackReference=dojo.hitch(this,"ServerStatusCallback");
            this.serverStatusChecker.execute(); 
       }
    },
    stopDeploymentEnvironment: function(){
	//defect 138864
			if(this.de.getDeEnvironmentType()=="Process Center")
			{
				this.showthisthing(this.depProcessCenterStopping);
				this.hidethisthing(this.depProcessCenterStop);
			}
			else if(this.de.getDeEnvironmentType()=="Process Server")
			{
				this.showthisthing(this.depProcessServerStopping);
				this.hidethisthing(this.depProcessServerStop);
			}
        if(this.de.stopDeploymentEnvironment()){
            this.showQuickStartLinks();
         } 
    },
    
    isCellCredentialSet: function(){
        if (this.getCellUserName() == null || this.getCellPassword() == null){
            return false;
        } else {
            return true;
        }
    },
    
    promptForCellCredential: function(callback){
    	//137696 (0 - command prompt mode 1 - shortcuts mode) If the mode is 1, give user more chance to correct the username and password.
        //if(!this.isCellCredentialSet()){
        if((this.mode==0 && (!this.isCellCredentialSet())) || this.mode==1){
            this.cellCredentialsDialogReference = new com.ibm.bpm.QuickStart.ui.dialogs.CellCredentialsDialog();
            this.cellCredentialsDialogReference.callerOkCallback = dojo.hitch(this,this.cellCredentialDialogOkListener);
            this.cellCredentialsDialogReference.callerCancelCallback = dojo.hitch(this, this.cellCredentialDialogCancelListener);
            this.cellCredentialsDialogReference.callerCallback = callback;
            this.cellCredentialsDialogReference.show();
         } else {
            callback();
         }
    },
    
    startDeploymentEnvironment: function(){
		if(this.de.getDeEnvironmentType()=="Process Center")
			{
				this.showthisthing(this.depProcessCenterStarting);
				this.hidethisthing(this.depProcessCenterStart);
			}
			else if(this.de.getDeEnvironmentType()=="Process Server")
			{
				this.showthisthing(this.depProcessServerStarting);
				this.hidethisthing(this.depProcessServerStart);
			}
        
        if(this.de.startDeploymentEnvironment()){
            document.getElementById("systemApplicationStatusCheckID").innerHTML=property('section.systemStatus');
            this.showQuickStartLinks(); 
            this.serverStatusChecker = com.ibm.bpm.QuickStart.step.ServerStatus();
            this.serverStatusChecker.stepCheckerReference=dojo.hitch(this,"stepChecker");
            this.serverStatusChecker.callbackReference=dojo.hitch(this,"ServerStatusCallback");
            this.serverStatusChecker.execute(); 

        }else {
            //show unknown error
        }
        
    },
    
    registerOnClickCallback: function(){
        var stopOnClickHandler =  null;
        var startOnClickHandler = null;
        if(!this.isCellCredentialSet()){
                stopOnClickHandler = dojo.hitch(this,"promptForCellCredential",dojo.hitch(this,"stopDeploymentEnvironment"));
                startOnClickHandler = dojo.hitch(this,"promptForCellCredential",dojo.hitch(this,"startDeploymentEnvironment"));
           } else {
                stopOnClickHandler = dojo.hitch(this,"stopDeploymentEnvironment",null);
                startOnClickHandler = dojo.hitch(this,"startDeploymentEnvironment",null);
           }

        this._connections.push(dojo.connect(this.serverAdministrationStopLink, "onclick", this, stopOnClickHandler));
        this._connections.push(dojo.connect(this.serverAdministrationStartLink, "onclick", this, startOnClickHandler));
        
        this._connections.push(dojo.connect(this.depProcessCenterStopLink, "onclick", this, stopOnClickHandler));
        this._connections.push(dojo.connect(this.depProcessCenterStartLink, "onclick", this, startOnClickHandler));


        this._connections.push(dojo.connect(this.depProcessServerStopLink, "onclick", this, stopOnClickHandler));
        this._connections.push(dojo.connect(this.depProcessServerStartLink, "onclick", this, startOnClickHandler));

        this._connections.push(dojo.connect(this.adminConsoleWebSphereLink, "onclick", this, function(){
            viewPage(NO_DISKID,this.de.getDmgr().getUrl());
         }));

        this._connections.push(dojo.connect(this.adminConsoleProcessAdminLink, "onclick", this, function(){
        viewPage(NO_DISKID,this.de.getFirstOnlineProcessAdmin().getUrl());
        }));

        this._connections.push(dojo.connect(this.adminConsolePerformanceDataWarehouseLink, "onclick", this, function(){
        viewPage(NO_DISKID,this.de.getFirstOnlinePerformanceAdmin().getUrl());
        }));

        this._connections.push(dojo.connect(this.processApplicationProcessCenterLink, "onclick", this, function(){
        viewPage(NO_DISKID,this.de.getFirstOnlineProcessCenter().getUrl());
        }));

        this._connections.push(dojo.connect(this.processApplicationPortalLink, "onclick", this, function(){
        viewPage(NO_DISKID,this.de.getFirstOnlineProcessPortal().getUrl());}));
        
      
    },
    
    
    showQuickStartLinks: function(){
       var method = "showQuickStartLinks";
       this.logger.entering(this.clazz,method,"Populating the links");
       this.resetControls();
      
 
       if(this.de.getDeType()=="Express"){
           this.showthisthing(this.sectionServerAdministrationTitle);
           if(this.de.isOnline()){
                   this.showthisthing(this.serverAdministrationStop);
          
           } else {
                   this.showthisthing(this.serverAdministrationStart);
           }
       
       } else{
           this.showthisthing(this.sectionDepTitle);
		   this.showthisthing(this.depinformation);
           if(this.de.isOnline()){
               if(this.de.getDeEnvironmentType()=="Process Center"){
                   this.showthisthing(this.depProcessCenterStop);
				   this.hidethisthing(this.depinformation);
                   
               }else if(this.de.getDeEnvironmentType()=="Process Server"){
                   this.showthisthing(this.depProcessServerStop); 
				   this.hidethisthing(this.depinformation);
               }
           } else {
               if(this.de.getDeEnvironmentType()=="Process Center"){
                   this.showthisthing(this.depProcessCenterStart);
				   this.hidethisthing(this.depinformation);
               }else if(this.de.getDeEnvironmentType()=="Process Server"){
                   this.showthisthing(this.depProcessServerStart);
				   this.hidethisthing(this.depinformation);
               }
           }
       }
       var isShowAdminConsoleSection = false;
       if(this.de.getDmgr() && this.de.getDmgr().isOnline()){
            isShowAdminConsoleSection= true;
            this.showthisthing(this.adminConsoleWebSphere);
                  
       }
       if( this.de.getFirstOnlineProcessAdmin()  && this.de.getFirstOnlineProcessAdmin().isOnline()){
                isShowAdminConsoleSection = true;
                this.showthisthing(this.adminConsoleProcessAdmin);

       }
       
       if(this.de.getFirstOnlinePerformanceAdmin()  && this.de.getFirstOnlinePerformanceAdmin().isOnline()){
                isShowAdminConsoleSection = true;
                this.showthisthing(this.adminConsolePerformanceDataWarehouse);
       }
       if(isShowAdminConsoleSection){
           this.showthisthing(this.sectionAdminConsoleTitle);
       }
       
       var isShowProcessAdminSection = false;
       if(this.de.getDeEnvironmentType()=="Process Center"){
           if( this.de.getFirstOnlineProcessCenter() && this.de.getFirstOnlineProcessCenter().isOnline()){
                isShowProcessAdminSection = true;
                this.showthisthing(this.processApplicationProcessCenter);               
           }
       }   

       if(this.de.getFirstOnlineProcessPortal() && this.de.getFirstOnlineProcessPortal().isOnline()){
            isShowProcessAdminSection = true;
       		this.showthisthing(this.processApplicationPortal);  

       }
       if(isShowProcessAdminSection){
           this.showthisthing(this.sectionProcessApplicationTitle);
        }
        
        if(this.de.getDeType()!="AdvancedOnly"){
            if(this.de.getDmgr() && this.de.getDmgr().isOnline() && !(this.de.getFirstOnlineProcessAdmin()  && this.de.getFirstOnlineProcessAdmin().isOnline() &&
            this.de.getFirstOnlinePerformanceAdmin()  && this.de.getFirstOnlinePerformanceAdmin().isOnline())
            ){
            
               document.getElementById("systemApplicationStatusCheckID").innerHTML=document.getElementById("systemApplicationStatusCheckID").innerHTML+"..";
               this.showthisthing(this.systemApplicationStatusCheck);
            }
        }        
       this.logger.exiting(this.clazz,method,"End of populating the links");
       // TODO ADD PD

    },
    
    stepChecker: function(){
        if( this.de.getFirstOnlineProcessAdmin()  && this.de.getFirstOnlineProcessAdmin().isOnline() &&
            this.de.getFirstOnlinePerformanceAdmin()  && this.de.getFirstOnlinePerformanceAdmin().isOnline()
        ){
            return true;
        } else {
           document.getElementById("systemApplicationStatusCheckID").innerHTML=document.getElementById("systemApplicationStatusCheckID").innerHTML+"..";
           this.showthisthing(this.systemApplicationStatusCheck);
            return false;
        }
    },
    
    ServerStatusCallback: function(){
         if(this.serverStatusChecker.getIsStepSuccess()==false){
            document.getElementById("systemApplicationStatusCheckID").innerHTML = property ('section.systemStatus.failed');
         }
         this.showQuickStartLinks();
         this.serverStatusChecker = null;  // removing the instance
    }
});
