// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96
// Copyright IBM Corporation 2013. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("com.ibm.bpm.QuickStart.utils.Logger");
dojo.require("com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper");

dojo.declare("com.ibm.bpm.QuickStart.utils.Logger", null, {
    logFile: null,
    
    constructor: function(fileName){
        if(fileName!=null){
            this.logFile = com.ibm.bpm.QuickStart.Helpers.LaunchpadHelper.getPersistedTempFilename(fileName);
        } else {
            //throw error
        }
    },
    
    getLogFile: function(){
        return this.logFile;
    },

    logMessage: function(message){
        var now = new Date().getTime();
        message = "" + now + " " + message;
        
        if (top.isWindows()) {
            message += "\r\n";
        }
        else {
            message += "\n";
        }
        top.writeTextFile(this.getLogFile(), message, true, "UTF-8");
    },
    
    entering: function(clazz,method,message){
        this.logMessage(clazz+" "+ method + " " + message);
    },
    exiting: function(clazz,method,message){
        this.logMessage(clazz+" "+ method + " " + message);
    }
    
});
